# $Revision: 1.38 $, $Date: 2012/03/09 17:53:12 $
%bcond_without	static
%bcond_without	tests
#
Summary:	MirBSD Korn Shell
Summary(pl.UTF-8):	Powłoka Korna z MirBSD
Name:		mksh
Version:	40d
Release:	3
License:	BSD
Group:		Applications/Shells
Source0:	http://www.mirbsd.org/MirOS/dist/mir/mksh/%{name}-R%{version}.cpio.gz
# Source0-md5:	c6428401103367730a95b99284bf47dc
Source1:	%{name}-mkshrc
Patch0:		%{name}-mkshrc_support.patch
Patch1:		%{name}-circumflex.patch
Patch2:		%{name}-no_stop_alias.patch
Patch3:		%{name}-distro.patch
Patch4:		%{name}-cmdline-length.patch
Patch5:		%{name}-columns.patch
URL:		https://www.mirbsd.org/mksh.htm
%if %{with tests}
BuildRequires:	ed
BuildRequires:	perl-base
%endif
%{?with_static:BuildRequires:   glibc-static}
BuildRequires:	rpmbuild(macros) >= 1.462
# is needed for /etc directory existence
Requires(pre):	FHS
Requires:	setup >= 2.4.6-2
Obsoletes:	pdksh
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_bindir			/bin

%description
mksh is the MirBSD enhanced version of the Public Domain Korn shell
(pdksh), a Bourne-compatible shell which is largely similar to the
original AT&T Korn shell. It includes bug fixes and feature
improvements in order to produce a modern, robust shell good for
interactive and especially script use. It has UTF-8 support in the
emacs command line editing mode; corresponds to OpenBSD 4.2-current
ksh sans GNU bash-like $PS1; the build environment requirements are
autoconfigured; throughout code simplification/bugfix/enhancement has
been done, and the shell has extended compatibility to other modern
shells.

%description -l pl.UTF-8
mksh to pochodząca z MirBSD rozszerzona wersja powłoki Public Domain
Korn Shell (pdksh) - kompatybilnej z powłoką Bourne'a, w większości
zbliżonej do oryginalnej powłoki Korna z AT&T. Zawiera poprawki błędów
i rozszerzenia mające na celu stworzenie współczesnej powłoki o
bogatych możliwościach do użytku interaktywnego i (zwłaszcza) w
skryptach. Ma obsługę UTF-8 w trybie edycji linii poleceń w stylu
emacsa; $PS1 odpowiada temu z ksh obecnym w OpenBSD 4.2-current;
środowisko budowania jest automatycznie konfigurowane; dzięki
wykonanym uproszczeniom kodu, poprawkom i rozszerzeniom powłoka ma
rozszerzoną kompatybilność z innymi współczesnymi powłokami.

%package static
Summary:	Statically linked the MirBSD enhanced version of pdksh
Summary(pl.UTF-8):	Skonsolidowana statycznie powłoka mksh
Group:		Applications/Shells
# requires base for /etc/mkshrc?
Requires:	%{name} = %{version}-%{release}

%description static
mksh is the MirBSD enhanced version of the Public Domain Korn shell
(pdksh), a Bourne-compatible shell which is largely similar to the
original AT&T Korn shell.

This packege contains statically linked version of mksh.

%description static -l pl.UTF-8
mksh to pochodząca z MirBSD rozszerzona wersja powłoki Public Domain
Korn Shell (pdksh) - kompatybilnej z powłoką Bourne'a, w większości
zbliżonej do oryginalnej powłoki Korna z AT&T.

W tym pakiecie jest mksh skonsolidowany statycznie.

%prep
%setup -qcT
gzip -dc %{SOURCE0} | cpio -mid
mv mksh/* .; rmdir mksh

%patch0 -p0
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p0

sed -i -e 's#@DISTRO@#PLD/Linux 3.0#g' check.t sh.h

%build
install -d out

CC="%{__cc}" \
CFLAGS="%{rpmcflags}" \
LDFLAGS="%{rpmldflags}" \
CPPFLAGS="%{rpmcppflags}" \
sh ./Build.sh -Q -r -j -c lto

# skip some tests if not on terminal
if ! tty -s; then
	skip_tests="-C regress:no-ctty"
fi

%{?with_tests:./test.sh -v $skip_tests}
mv mksh out/mksh.dynamic

%if %{with static}
CC="%{__cc}" \
CFLAGS="%{rpmcflags}" \
LDFLAGS="%{rpmldflags} -static" \
CPPFLAGS="%{rpmcppflags}" \
sh ./Build.sh -Q -r -j -c lto

%{?with_tests:./test.sh -v $skip_tests}
mv mksh out/mksh.static
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_mandir}/man1}
install -p out/mksh.dynamic $RPM_BUILD_ROOT%{_bindir}/mksh
%{?with_static:install -p out/mksh.static $RPM_BUILD_ROOT%{_bindir}/mksh.static}

cp -a mksh.1 $RPM_BUILD_ROOT%{_mandir}/man1/mksh.1
echo ".so mksh.1" > $RPM_BUILD_ROOT%{_mandir}/man1/sh.1

install -D %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/mkshrc
ln -sf mksh $RPM_BUILD_ROOT%{_bindir}/sh

# some pdksh scripts used that
ln -sf mksh $RPM_BUILD_ROOT%{_bindir}/ksh

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p %add_etc_shells -p /bin/sh /bin/ksh /bin/mksh
%preun  -p %remove_etc_shells -p /bin/sh /bin/ksh /bin/mksh

%posttrans -p %add_etc_shells -p /bin/sh /bin/ksh


%post static -p %add_etc_shells -p /bin/mksh.static
%preun static -p %remove_etc_shells -p /bin/mksh.static

%files
%defattr(644,root,root,755)
%doc dot.mkshrc
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/mkshrc
%attr(755,root,root) %{_bindir}/mksh
%attr(755,root,root) %{_bindir}/ksh
%attr(755,root,root) %{_bindir}/sh
%{_mandir}/man1/mksh.1*
%{_mandir}/man1/sh.1*

%if %{with static}
%files static
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/mksh.static
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mksh.spec,v $
Revision 1.38  2012/03/09 17:53:12  draenog
- non-interactive mksh can inherit COLUMNS and LINES from parent process;
  fixes git-core-1.7.10-rc0 test suite

Revision 1.37  2012/01/15 16:09:18  arekm
- revert; with reduced echo -ne doesn't work

Revision 1.36  2012/01/15 14:38:26  arekm
- rel 2; build with MKSH_BINSHREDUCED (our old pdksh had this mode on by default thanks to -debian.patch). Gives us set -o sh behaviour for /bin/sh.

Revision 1.35  2011/12/11 20:11:15  arekm
- up to 40d

Revision 1.34  2011/11/22 21:27:11  arekm
- update to 40c; mkshrc improved based on maintainer suggestions/code

Revision 1.33  2011/10/18 16:39:06  arekm
- rel 2; use 16k cmdline buffer (previously 4k)

Revision 1.32  2011/07/25 17:05:41  arekm
- enable lto

Revision 1.31  2011/07/17 05:39:07  arekm
- up to 40b (tty/test patches in upstream)

Revision 1.30  2011/07/12 06:07:46  arekm
- drop extra space from version

Revision 1.29  2011/07/12 06:04:43  arekm
- mark version as PLD; requested by upstream

Revision 1.28  2011/07/08 09:17:31  arekm
- release 5

Revision 1.27  2011/07/08 06:06:28  arekm
- add /bin/ksh to shells

Revision 1.26  2011/07/08 05:54:17  arekm
- release 4

Revision 1.25  2011/07/07 21:05:36  arekm
- turns out there is a option for skipping tty-using tests, so no need for awk

Revision 1.24  2011/07/07 21:02:34  arekm
- rel 3; test suite passes on builders

Revision 1.23  2011/07/07 20:59:53  arekm
- utf8opt-3 test needs tty

Revision 1.22  2011/07/07 20:55:39  arekm
- skip some tests if not run with a terminal

Revision 1.21  2011/07/07 20:25:56  arekm
- rel 2; should be ready for general consumption

Revision 1.20  2011/07/07 20:21:09  arekm
- provide /bin/ksh symlink; make builder script working (from ksh devs)

Revision 1.19  2011/07/07 16:47:15  draenog
- remove default stop=kill -STOP alias; too generic

Revision 1.18  2011/07/07 16:38:01  arekm
- circumflex.patch is back

Revision 1.17  2011/07/07 16:14:32  arekm
- additional add_etc_shells for /bin/sh at posttrans (so removing pdksh won't remove /bin/sh from there)

Revision 1.16  2011/07/07 15:56:49  arekm
- package /bin/sh, typo fixed

Revision 1.15  2011/07/07 15:54:17  arekm
- /bin/sh symlink fix

Revision 1.14  2011/07/07 15:51:36  arekm
- add static version; prepare this shell to be /bin/sh

Revision 1.13  2011/07/07 11:58:59  draenog
- mkshrc_support.patch: add support for system wide mkshrc file, change
  name of i variable in tests as it is unset by PLD shrcd files
- mkshrc file copied from pdksh package

Revision 1.12  2011/07/06 16:24:41  draenog
- adapterized
- rel. 1

Revision 1.11  2011/06/13 19:30:48  draenog
- up to R40
- arc4random.c not longer used
- tests use perl and ed

Revision 1.10  2010/08/24 23:21:48  pawelz
- up to 39c

Revision 1.9  2010/02/22 21:52:39  arekm
- up to 39; rpmcppflags in use; tests bcond

Revision 1.8  2010/02/22 19:32:33  glen
- use %lua_{remove|add}_etc_shells macros
- FHS and setup macros should be automatic

Revision 1.7  2008/10/26 17:44:40  areq
- R36

Revision 1.6  2008/03/29 17:53:23  areq
- 33b

Revision 1.5  2008-02-23 06:06:20  qboosh
- pl

Revision 1.4  2007-10-16 02:11:02  glen
-  if /bin/sh is not removed it shouldn't be added either
  besides this pkg doesn't have it in %files

Revision 1.3  2007/10/16 02:07:21  glen
- cleanups, tabs, adapters

Revision 1.2  2007/10/15 23:39:31  areq
- fix setup

Revision 1.1  2007/10/15 23:27:24  areq
- raw PLD spec
